diff --git a/MAINTAINERS b/MAINTAINERS
index f29195850c16..c9333d46047e 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -11964,7 +11964,7 @@ L:	linux-tegra@vger.kernel.org
 S:	Maintained
 T:	git git://linuxtv.org/media_tree.git
 F:	Documentation/devicetree/bindings/media/nvidia,tegra-vde.txt
-F:	drivers/media/platform/tegra/vde/
+F:	drivers/media/platform/nvidia/tegra-vde/
 
 MEDIA DRIVERS FOR RENESAS - CEU
 M:	Jacopo Mondi <jacopo@jmondi.org>
diff --git a/drivers/media/platform/Kconfig b/drivers/media/platform/Kconfig
index 5ffbbd6c6f91..f07ab9a98e3b 100644
--- a/drivers/media/platform/Kconfig
+++ b/drivers/media/platform/Kconfig
@@ -83,6 +83,7 @@ source "drivers/media/platform/mediatek/mtk-jpeg/Kconfig"
 source "drivers/media/platform/mediatek/mtk-mdp/Kconfig"
 source "drivers/media/platform/mediatek/mtk-vcodec/Kconfig"
 source "drivers/media/platform/mediatek/mtk-vpu/Kconfig"
+source "drivers/media/platform/nvidia/tegra-vde/Kconfig"
 source "drivers/media/platform/nxp/Kconfig"
 source "drivers/media/platform/omap/Kconfig"
 source "drivers/media/platform/omap3isp/Kconfig"
@@ -95,7 +96,6 @@ source "drivers/media/platform/s5p-jpeg/Kconfig"
 source "drivers/media/platform/s5p-mfc/Kconfig"
 source "drivers/media/platform/sti/Kconfig"
 source "drivers/media/platform/stm32/Kconfig"
-source "drivers/media/platform/tegra/vde/Kconfig"
 source "drivers/media/platform/ti-vpe/Kconfig"
 source "drivers/media/platform/via/Kconfig"
 source "drivers/media/platform/xilinx/Kconfig"
diff --git a/drivers/media/platform/Makefile b/drivers/media/platform/Makefile
index 88519e902919..ce9909534218 100644
--- a/drivers/media/platform/Makefile
+++ b/drivers/media/platform/Makefile
@@ -23,6 +23,7 @@ obj-y += mediatek/mtk-jpeg/
 obj-y += mediatek/mtk-mdp/
 obj-y += mediatek/mtk-vcodec/
 obj-y += mediatek/mtk-vpu/
+obj-y += nvidia/tegra-vde/
 obj-y += nxp/
 obj-y += omap/
 obj-y += omap3isp/
@@ -40,7 +41,6 @@ obj-y += sti/c8sectpfe/
 obj-y += sti/delta/
 obj-y += sti/hva/
 obj-y += stm32/
-obj-y += tegra/vde/
 obj-y += ti-vpe/
 obj-y += via/
 obj-y += xilinx/
diff --git a/drivers/media/platform/tegra/vde/Kconfig b/drivers/media/platform/nvidia/tegra-vde/Kconfig
similarity index 100%
rename from drivers/media/platform/tegra/vde/Kconfig
rename to drivers/media/platform/nvidia/tegra-vde/Kconfig
diff --git a/drivers/media/platform/tegra/vde/Makefile b/drivers/media/platform/nvidia/tegra-vde/Makefile
similarity index 100%
rename from drivers/media/platform/tegra/vde/Makefile
rename to drivers/media/platform/nvidia/tegra-vde/Makefile
diff --git a/drivers/media/platform/tegra/vde/dmabuf-cache.c b/drivers/media/platform/nvidia/tegra-vde/dmabuf-cache.c
similarity index 100%
rename from drivers/media/platform/tegra/vde/dmabuf-cache.c
rename to drivers/media/platform/nvidia/tegra-vde/dmabuf-cache.c
diff --git a/drivers/media/platform/tegra/vde/h264.c b/drivers/media/platform/nvidia/tegra-vde/h264.c
similarity index 100%
rename from drivers/media/platform/tegra/vde/h264.c
rename to drivers/media/platform/nvidia/tegra-vde/h264.c
diff --git a/drivers/media/platform/tegra/vde/iommu.c b/drivers/media/platform/nvidia/tegra-vde/iommu.c
similarity index 100%
rename from drivers/media/platform/tegra/vde/iommu.c
rename to drivers/media/platform/nvidia/tegra-vde/iommu.c
diff --git a/drivers/media/platform/tegra/vde/trace.h b/drivers/media/platform/nvidia/tegra-vde/trace.h
similarity index 97%
rename from drivers/media/platform/tegra/vde/trace.h
rename to drivers/media/platform/nvidia/tegra-vde/trace.h
index 77358ddfdb8f..7853ab095ca4 100644
--- a/drivers/media/platform/tegra/vde/trace.h
+++ b/drivers/media/platform/nvidia/tegra-vde/trace.h
@@ -90,6 +90,6 @@ TRACE_EVENT(vde_ref_l1,
 
 /* This part must be outside protection */
 #undef TRACE_INCLUDE_PATH
-#define TRACE_INCLUDE_PATH ../../drivers/media/platform/tegra/vde
+#define TRACE_INCLUDE_PATH ../../drivers/media/platform/nvidia/tegra-vde
 #define TRACE_INCLUDE_FILE trace
 #include <trace/define_trace.h>
diff --git a/drivers/media/platform/tegra/vde/v4l2.c b/drivers/media/platform/nvidia/tegra-vde/v4l2.c
similarity index 100%
rename from drivers/media/platform/tegra/vde/v4l2.c
rename to drivers/media/platform/nvidia/tegra-vde/v4l2.c
diff --git a/drivers/media/platform/tegra/vde/vde.c b/drivers/media/platform/nvidia/tegra-vde/vde.c
similarity index 100%
rename from drivers/media/platform/tegra/vde/vde.c
rename to drivers/media/platform/nvidia/tegra-vde/vde.c
diff --git a/drivers/media/platform/tegra/vde/vde.h b/drivers/media/platform/nvidia/tegra-vde/vde.h
similarity index 100%
rename from drivers/media/platform/tegra/vde/vde.h
rename to drivers/media/platform/nvidia/tegra-vde/vde.h